function BT = R2BT(R, q, T, ctol); 
if ~exist('tol', 'var') || isempty(tol), tol = 1e-8; end % <default-tol>
if ~exist('ctol', 'var') || isempty(ctol), ctol = tol; end % <default-ctol>
%% <ctol2c>
if isscalar(ctol) % estimate c from BT or wd
  if exist('R', 'var') && ~exist('BT', 'var'), BT = null(R); end
  if exist('BT', 'var'), [c, m, ell, n] = BT2c(BT, q, ctol); 
  elseif exist('wd', 'var'), [c, m, ell, n] = c_mpum(wd, ctol); end
else % ctol should specify complexity 
  c = ctol; m = c(1); ell = c(2); n = c(3);
end
MT = multmat(R, q, T);
if length(ctol) == 3
  [~, BT] = lra(MT', q * T - c2r(c, T)); BT = BT'; 
else
  [~, BT] = lra(MT', ctol); BT = BT'; 
end
