function Bh = w2ss(wd, io, ctol) 
if ~exist('tol', 'var') || isempty(tol), tol = 1e-8; end % <default-tol>
if ~exist('ctol', 'var') || isempty(ctol), ctol = tol; end % <default-ctol>
%% <ctol2c>
if isscalar(ctol) % estimate c from BT or wd
  if exist('R', 'var') && ~exist('BT', 'var'), BT = null(R); end
  if exist('BT', 'var'), [c, m, ell, n] = BT2c(BT, q, ctol); 
  elseif exist('wd', 'var'), [c, m, ell, n] = c_mpum(wd, ctol); end
else % ctol should specify complexity 
  c = ctol; m = c(1); ell = c(2); n = c(3);
end
q = size(wd, 2);
if ~exist('io', 'var') || isempty(io), io = 1:q; end % <default-io>
BT = w2BT(wd, 2  * ell + 1, c);
Bh = BT2ss(BT, q, io, c);
